/// <reference types="react" />
import * as React from 'react';
import { FormikActions, FormikComputedProps, FormikHandlers, FormikSharedConfig, FormikState, FormikValues } from './formik';
export declare type InjectedFormikProps<Props, Values> = Props & FormikState<Values> & FormikActions<Props> & FormikHandlers & FormikComputedProps;
export declare type FormikBag<P, V> = {
    props: P;
} & FormikActions<P>;
export interface WithFormikConfig<Props, Values extends FormikValues = FormikValues, DeprecatedPayload = Values> extends FormikSharedConfig {
    displayName?: string;
    handleSubmit: (values: object, formikBag: FormikBag<Props, Values>) => void;
    mapPropsToValues?: (props: Props) => Values;
    mapValuesToPayload?: (values: Values) => DeprecatedPayload;
}
export declare type CompositeComponent<P> = React.ComponentClass<P> | React.StatelessComponent<P>;
export interface ComponentDecorator<TOwnProps, TMergedProps> {
    (component: CompositeComponent<TMergedProps>): React.ComponentClass<TOwnProps>;
}
export interface InferableComponentDecorator<TOwnProps> {
    <T extends CompositeComponent<TOwnProps>>(component: T): T;
}
export declare function withFormik<Props, Values extends FormikValues, Payload = Values>({mapPropsToValues, ...config}: WithFormikConfig<Props, Values, Payload>): ComponentDecorator<Props, InjectedFormikProps<Props, Values>>;
